package com.glarimy.patterns;

import java.util.List;

public class Console {
	// 1 is user
	// 2 is owner
	public static void main(String[] args) throws Exception {
		Directory directory = new SimpleDirectory();
		Credential credential = new Credential();
		Name name = new Name();
		name.setFirstName("Krishna");
		name.setLastName("Koyya");

		credential.setName(name);
		credential.setPassword("123");
		credential.setRole(1);

		Contact contact = new Contact();
		contact.setName(name);
		contact.setEmail("krishna@glarimy.com");

		int id = directory.signin(credential);
		credential.setId(id);
		directory.login(credential);
		directory.add(contact);
		List<Contact> list = directory.list();
		for (Contact c : list)
			System.out.println(c);
	}

}
