package com.glarimy.patterns;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ObjectStore {
	private Map<Object, Object> objects;

	public ObjectStore() {
		objects = new HashMap<Object, Object>();
	}

	public void create(Object key, Object value) {
		objects.put(key, value);
	}

	public Object read(Object key) {
		return objects.get(key);
	}

	public List<Object> read() {
		return new ArrayList<Object>(objects.values());
	}

	public void update(Object key, Object value) {
		objects.put(key, value);
	}

	public void delete(Object key) {
		objects.put(key, null);
	}

	public static void main(String[] args) {
		int a = 1;
		int b = 1;

		ObjectStore store = new ObjectStore();
		store.create(a, a);
		System.out.println(store.read(b));

		Credential credential = new Credential();
		credential.setId(25);
		store.create(credential.getId(), credential);
	}
}