package com.glarimy.patterns;

import java.util.ArrayList;
import java.util.List;

public class SimpleDirectory implements Directory {
	private Security security;
	private ObjectStore store;

	public SimpleDirectory() throws Exception {
		security = new SimpleSecurity();
		store = new ObjectStore();
	}

	@Override
	public void add(Contact contact) throws Exception {
		if (security.inSession()) {
			security.authorize("add");
			store.create(contact.getName(), contact);
			return;
		}
		throw new Exception("Not logged in");
	}

	@Override
	public List<Contact> list() throws Exception {
		if (security.inSession()) {
			security.authorize("list");
			List<Object> objects = store.read();
			List<Contact> contacts = new ArrayList<Contact>();
			for (Object o : objects) {
				contacts.add((Contact) o);
			}
			return contacts;
		}
		throw new Exception("Not logged in");
	}

	@Override
	public List<Contact> search(Criteria criteria) throws Exception {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void update(Contact contact) throws Exception {
		// TODO Auto-generated method stub

	}

	@Override
	public void login(Credential credential) throws Exception {
		security.authenticate(credential);

	}

	@Override
	public void logout(Credential credential) throws Exception {
		security.invalidate();
	}

	@Override
	public int signin(Credential credential) throws Exception {
		return security.add(credential);
	}

}
