package com.glarimy.patterns;

public class SimpleSecurity implements Security {
	private Credential credential;
	private ObjectStore store;
	private int next;

	public SimpleSecurity() {
		store = new ObjectStore();
		next = 1;
	}

	@Override
	public void authenticate(Credential credential) throws Exception {
		Object o = store.read(credential.getId());
		if (o == null)
			throw new Exception("Authentication failed!");
		Credential c = (Credential) o;
		if (c.getPassword().equalsIgnoreCase(credential.getPassword()))
			this.credential = c;
		else
			throw new Exception("Authentication failed!");
	}

	@Override
	public int add(Credential credential) throws Exception {
		credential.setId(next++);
		store.create(credential.getId(), credential);
		return credential.getId();
	}

	@Override
	public void remove(int id) throws Exception {
		store.delete(id);
	}

	@Override
	public void authorize(String task) throws Exception {
		switch (credential.getRole()) {
		case 1:
			if (task.equalsIgnoreCase("add") || task.equalsIgnoreCase("update"))
				throw new Exception("Authorization failed");
		default:
			return;
		}
	}

	@Override
	public boolean inSession() throws Exception {
		if (credential != null)
			return true;
		return false;
	}

	@Override
	public void invalidate() throws Exception {
		credential = null;

	}
}